/* N-body calculation, adapted from C* Ref. Man., pg. 38 ff. */
/* Testing scalar references */
#include <stdio.hs>
/*#include <math.hs>*/

/* Number of bodies in the calculation */
#define N 6
/* Number of distinct pairs of bodies */
#define SZ ((N * (N - 1)) / 2)

float G;     /* Gravitational constant */

/* The bodies */

domain particle { float x, y, z, m, vx, vy, vz, ax, ay, az; };

domain particle B[N];

/* Pairs of particles */

domain pair { int i, j; };

domain pair P[SZ];

/* Pairs will be represented asymmetrically.  The function setup
   (below) initializes these.  */
/*
void pair::setup()
 { mono int nx = N - 2;
   i = 0;  j = 1 + (this - &P[0]);
   while ( j >= N ) { i++;  j -= nx--; }
 }

void pair::print_pairs()
 { mono int k;
   for ( k = 0; k < SZ; k++ ) printf("%2d ", P[k].i);
   printf("\n");
   for ( k = 0; k < SZ; k++ ) printf("%2d ", P[k].j);
   printf("\n");
 }
*/
FILE *datap;      /* Stream for reading data */

/* Load inital positions, velocities, also masses, gravitational const. */
/*
void particle::init()
 { mono int k;
   for ( k = 0; k < N; k++ )
     fscanf(datap, "%e%e%e", &B[k].x,  &B[k].y,  &B[k].z);
   for ( k = 0; k < N; k++ )
     fscanf(datap, "%e%e%e", &B[k].vx, &B[k].vy, &B[k].vz);
   for ( k = 0; k < N; k++ ) fscanf(datap, "%e", &B[k].m);
   fscanf(datap, "%e", &G);
 } */
void test()
 { int k;
   for (k = 0; k < N; k++ )
    { B[k].x = 1.0;  B[k].y = 2.0;  B[k].z = 3.0;
      B[k].vx = -1.0;  B[k].vy = -2.0;  B[k].vz = -3.0;
      B[k].m = 36.7;  G = 0.1234;
    }
 }

void particle::print_state()
 { mono int k;
   printf(
  "\n        x         y         z         vx        vy        vz        m\n");
   for ( k = 0; k < N; k++ )
     printf ("%3d %9.2g %9.2g %9.2g %9.2g %9.2g %9.2g %9.2g\n",
              k, B[k].x, B[k].y, B[k].z, B[k].vx, B[k].vy, B[k].vz, B[k].m);
 }

void main()
 {/* [domain pair].{ setup();  print_pairs(); }; */
   datap = fopen("sixbody.dat", "r");
   [domain particle].{ test();  print_state(); };
 }
